LinHES - Bug # 317: Diskless FrontEnd creation script
Description: Hi all,

I'm currently running R5F27 using two diskless FrontEnds of which | am a huge fan for a number of reasons.
Unfortunately | am no linux-head but | had a friend visiting recently who is and he attempted to edit the
config_diskless_frontend.bash script developed in
[[http://mysettopbox.tv/phpBB2/viewtopic.php?t=10098&postdays=0&postorder=asc&start=0&sid=b86e0e920
f6fea5f683dd143a6bb6079|this thread]]. He manually installed dhcpd & tftpd beforehand but the rest should
be in the script. | used it and have one diskless FE running but | can't gurantee anything in this script. My
friend also knew nothing about arch linux and he coded it very quickly so again, no guarantees. But it would
be an awesome feature to have OOTB in LInHES and even better if it was all nicely menu-driven.

History

04/07/2009 02:48 pm - poflynn
Scripts created by my friend.

06/19/2009 06:08 pm - GregFrost
So it seems from the forum posts http://knoppmyth.net/phpBB2/viewtopic.php?t=10098&start=185 that we need a package with dhcpd in the LinHES
repo. I'll see what | can do.

06/19/2009 11:07 pm - GregFrost

| have added PKGBUILDS for dhcpd and tftpd to the repository and updated runit-scripts with run scripts for them. jams or cesman (or bob?) will need
to build the packages to make them available. | am working on an updated config_diskless_frontend.bash that enables the required services. Im not
sure where it should go. It should probably be in LinHES-config, but | note that it looks like someone has already created a script in there called

build_diskless.sh. Is that supposed to replace config_diskless_frontend.bash?

06/20/2009 12:07 am - poflynn
| hope this q isn't directed at me because | have no idea how to answer it :-) Given the lack of activity from that thread from anyone other than me, I'd be

surprised if someone wrote an R6 version of this script. Thanks for the efforts!

06/20/2009 08:08 pm - GregFrost

With the dhcpd and tftpd packages | have included, my frontend gets an ip from the dhcp server and then tftps the initial kernel, but then fails to access
root via nfs. Im not sure why, but that is the next puzzle to solve. paul: Do you know if your friend needed to compile a new kernel with new
configuration options in order to get it working on R6?

06/20/2009 10:25 pm - poflynn

| pretty certain that he didn't, I'm sure he would have mentioned something that drastic. His problems were mostly related to the init framework, he
definitely struggled with that, he was suspicious that "the linhes guys hi-jacked it" and other such comments. | am surprised that you're having this
problem, | created 2 FEs with it and they both worked really well. Maybe we should talk to that Craig guy on the discussion forum to see how far he's

got?

06/21/2009 04:30 am - GregFrost

Well, after looking into it further, | find that hard to believe because it would seem that the kernel in LinHES doesnt have any of the options selected
that the wiki page says are needed. Perhaps your friend didnt make a big deal about it because it was clear in the instructions on the wiki? Anyway, im
working on a new kernel configuration that will support diskless frontends. | am not sure of all of the implications of rebuilding the kernel. Hopefully | can
discuss this with cesman in IRC at some stage.

06/28/2009 05:53 am - GregFrost
The changes have been made to the kernel to support diskless frontends.

| have just added a package called diskless-legacy which works like the old knoppmyth diskless script with a few differences:

It doesnt attempt to share /usr by having the frontend mount it readonly. This allows packages to be added to the frontend only. It takes longer to build
the frontend, but it makes the frontend more independent.

| also changed it so that the pacman package cache is shared with the master backend.

Once cesman or jams or someone has built the binary packages, you should just need pacman -S diskless-legacy and it will install what is needed for

you to use the diskless script.

cesman/jams: please build and push a binary package to the repo.
Paul: please try it and let me know how you go.

06/28/2009 05:56 am - GregFrost
| almost forgot to mention: in order to build the LinHES config script after | had removed the config_diskless_frontend.bash file, | had to remove
reference to mythinstall.bin from the PKGBUILD because it is not in the git repo. This should probably be fixed as a matter of urgency.

07/18/2009 05:25 pm - iscraigh
| get to the same place....

updated backend and run config_diskless_frontend.bash script | notice an error about the nfs module.

| forge ahead.

| end up stuck at can't find /dev/nfs
Try to create it cant find /bin/mknod
When | look in the image on the backend mknod is present.

Delete and try again no errors this time but.
Still no go same place

unable to determine root file system

and the mknod nfs errors

any suggestions?

07/18/2009 07:58 pm - GregFrost
That sounds like your network module is not built into the kernel. Determine which module is being used by your network and check the kernel

configuration to see if this is the case. If it is, we can update the kernel config to build your module in.

09/13/2009 01:47 pm - poflynn

Finally got my new h/w and am building this out. Thx for the efforts so far Greg. | have a basic install of an mbe up and running & i downloaded and ran
this script. Seemed to run ok so | wandered over to my FE, hit the power button and was very excited to see it boot. However it got stuck starting X as it
has a different (VDPAU-compatible) gfx card so now | want to install the nvidia drivers, mythtv-vdpau pkg etc on the FE. | ran pacman but got an error
that it is unable to write pkg files from the FE. | double-checked /etc/exports on the mbe and everything appears to be shared out as rw. Also | was

running pacman as root on the FE. Any thoughts?

09/15/2009 12:20 am - poflynn

Ok, figured it out, note lines 385 and 407; | added the no_root_squash option to line 385 thus allowing updates to /data/var/cache/pacman from the
FEs. This should be added to the script.

Also | see the line below still in there; | commented this out from the R5F27 script as | didn't want the DHCP server interfering with my router's DHCP
server. This line ensures it only responds to PXE DHCP requests which | think is what most ppl would want but maybe not. Either way, might be a good

idea to update the comment to something more legible for ppl.

## POF allow booting;
09/16/2009 04:18 am - GregFrost

Paul, can you attach the script you ended up with so there is nothing lost in translation? Then I'll update the package.

03/21/2010 06:42 pm - jams

- Status changed from New to Closed

Closed due to lack of activity

Files

diskless.zip 6.4 kB 04/07/2009 admin
